%if 0%{?fedora} < 18 && 0%{?rhel} < 7
%define dbdep db4-devel
%else
%define dbdep libdb-devel
%endif

%if 0%{?rhel}
%define with_freetds 0
%else
%define with_freetds 1
%endif

%define apuver 1

Summary: Apache Portable Runtime Utility library
Name: apr-util-jws3
Version: 1.5.2
Release: 8%{?dist}
License: ASL 2.0
Group: System Environment/Libraries
URL: http://apr.apache.org/
Source0: http://www.apache.org/dist/apr/apr-util-%{version}.tar.bz2
Patch1: apr-util-1.2.7-pkgconf.patch
Patch2: apr-util-1.3.7-nodbmdso.patch
Patch3: apr-util-1.5.2-aarch64.patch
Patch4: apr-util-1.4.1-private.patch
Patch5: apr-util-configure.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: autoconf, apr-jws3-devel >= 1.3.0
BuildRequires: %{dbdep}, expat-devel, libuuid-devel

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

%package devel
Group: Development/Libraries
Summary: APR utility library development kit
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}, apr-jws3-devel%{?_isa}, pkgconfig
Requires: %{dbdep}%{?_isa}, expat-devel%{?_isa}, openldap-devel%{?_isa}

%description devel
This package provides the support files which can be used to 
build applications using the APR utility library.  The mission 
of the Apache Portable Runtime (APR) is to provide a free 
library of C data structures and routines.

%package pgsql
Group: Development/Libraries
Summary: APR utility library PostgreSQL DBD driver
BuildRequires: postgresql-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description pgsql
This package provides the PostgreSQL driver for the apr-util
DBD (database abstraction) interface.

%package mysql
Group: Development/Libraries
Summary: APR utility library MySQL DBD driver
BuildRequires: mysql-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description mysql
This package provides the MySQL driver for the apr-util DBD
(database abstraction) interface.

%package sqlite
Group: Development/Libraries
Summary: APR utility library SQLite DBD driver
BuildRequires: sqlite-devel >= 3.0.0
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description sqlite
This package provides the SQLite driver for the apr-util DBD
(database abstraction) interface.

%if %{with_freetds}

%package freetds
Group: Development/Libraries
Summary: APR utility library FreeTDS DBD driver
BuildRequires: freetds-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description freetds
This package provides the FreeTDS driver for the apr-util DBD
(database abstraction) interface.

%endif

%package odbc
Group: Development/Libraries
Summary: APR utility library ODBC DBD driver
BuildRequires: unixODBC-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description odbc
This package provides the ODBC driver for the apr-util DBD
(database abstraction) interface.

%package ldap
Group: Development/Libraries
Summary: APR utility library LDAP support
BuildRequires: openldap-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description ldap
This package provides the LDAP support for the apr-util.

%package openssl
Group: Development/Libraries
Summary: APR utility library OpenSSL crytpo support
BuildRequires: openssl-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description openssl
This package provides the OpenSSL crypto support for the apr-util.

%package nss
Group: Development/Libraries
Summary: APR utility library NSS crytpo support
BuildRequires: nss-devel
Requires: apr-util-jws3%{?_isa} = %{version}-%{release}

%description nss
This package provides the NSS crypto support for the apr-util.

%prep
%setup -q -n apr-util-%{version}
%patch1 -p1 -b .pkgconf
%patch2 -p1 -b .nodbmdso
%patch3 -p1 -b .aarch64
%patch4 -p1 -b .private

%build
autoheader && autoconf
# A fragile autoconf test which fails if the code trips
# any other warning; force correct result for OpenLDAP:
export ac_cv_ldap_set_rebind_proc_style=three

patch -p1 < %{PATCH5}
%configure --with-apr=%{_bindir}/apr-jws3-1-config \
        --includedir=%{_includedir}/apr-jws3-%{apuver} \
        --with-ldap=ldap_r --without-gdbm \
        --with-sqlite3 --with-pgsql --with-mysql --with-odbc \
%if %{with_freetds}
        --with-freetds \
%else
        --without-freetds \
%endif
        --with-berkeley-db \
        --without-sqlite2 \
        --with-crypto --with-openssl --with-nss
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{_datadir}/aclocal
install -m 644 build/find_apu.m4 $RPM_BUILD_ROOT/%{_datadir}/aclocal

# Unpackaged files; remove the static libaprutil
rm -f $RPM_BUILD_ROOT%{_libdir}/aprutil.exp \
      $RPM_BUILD_ROOT%{_libdir}/libaprutil-jws3*.a

# And remove the reference to the static libaprutil from the .la
# file.
sed -i '/^old_library/s,libapr.*\.a,,' \
      $RPM_BUILD_ROOT%{_libdir}/libaprutil-jws3*.la

# Remove unnecessary exports from dependency_libs
sed -ri '/^dependency_libs/{s,-l(pq|sqlite[0-9]|rt|dl|uuid) ,,g}' \
      $RPM_BUILD_ROOT%{_libdir}/libaprutil-jws3*.la

# Trim libtool DSO cruft
rm -f $RPM_BUILD_ROOT%{_libdir}/aprutil-jws3-%{apuver}/*.*a

# TODO: we need to enclose all the renaming part to el6 checking clause
# to maximum the portability.
%if "%{?rhel}" == "6"
sed -i 's/apr-1/apr-jws3-1/' $RPM_BUILD_ROOT%{_libdir}/pkgconfig/apr-util-1.pc
sed -i 's/pkg-config --variable=libdir apr-util-1/pkg-config --variable=libdir apr-util-jws3-1/' $RPM_BUILD_ROOT%{_bindir}/apu-%{apuver}-config

mv $RPM_BUILD_ROOT%{_libdir}/pkgconfig/apr-util-1.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/apr-util-jws3-1.pc
mv $RPM_BUILD_ROOT%{_datadir}/aclocal/find_apu.m4 $RPM_BUILD_ROOT%{_datadir}/aclocal/find_apu-jws3.m4 
mv $RPM_BUILD_ROOT%{_bindir}/apu-%{apuver}-config $RPM_BUILD_ROOT%{_bindir}/apu-jws3-%{apuver}-config
%endif

%check
# Run the less verbose test suites
export MALLOC_CHECK_=2 MALLOC_PERTURB_=$(($RANDOM % 255 + 1))
cd test
make %{?_smp_mflags} testall
# testall breaks with DBD DSO; ignore
export LD_LIBRARY_PATH="`echo "../dbm/.libs:../dbd/.libs:../ldap/.libs:$LD_LIBRARY_PATH" | sed -e 's/::*$//'`"
./testall -v -q || true
./testall testrmm
./testall testdbm

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE NOTICE
%{_libdir}/libaprutil-jws3-%{apuver}.so.*
%dir %{_libdir}/apr-util-jws3-%{apuver}

%files pgsql
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_dbd_pgsql*

%files mysql
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_dbd_mysql*

%files sqlite
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_dbd_sqlite*

%if %{with_freetds}

%files freetds
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_dbd_freetds*

%endif

%files odbc
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_dbd_odbc*

%files ldap
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_ldap*

%files openssl
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_crypto_openssl*

%files nss
%defattr(-,root,root,-)
%{_libdir}/apr-util-jws3-%{apuver}/apr_crypto_nss*

%files devel
%defattr(-,root,root,-)
%{_bindir}/apu-jws3-%{apuver}-config
%{_libdir}/libaprutil-jws3-%{apuver}.*a
%{_libdir}/libaprutil-jws3-%{apuver}.so
%{_includedir}/apr-jws3-%{apuver}/*.h
%{_libdir}/pkgconfig/*.pc
%{_datadir}/aclocal/*.m4

%changelog
* Thu Oct 30 2014 Weinan Li <weli@redhat.com> - 1.5.2-8
- Fix two renaming bugs

* Tue Oct 28 2014 Weinan Li <weli@redhat.com> - 1.5.2-7
- Rename to apr-util-jws3
- Build for jws3

* Fri Jan 24 2014 Daniel Mach <dmach@redhat.com> - 1.5.2-6
- Mass rebuild 2014-01-24

* Wed Jan 15 2014 Honza Horak <hhorak@redhat.com> - 1.5.2-5
- Rebuild for mariadb-libs
  Related: #1045013

* Fri Dec 27 2013 Daniel Mach <dmach@redhat.com> - 1.5.2-4
- Mass rebuild 2013-12-27

* Thu May 09 2013 Jan Kaluza <jkaluza@redhat.com> - 1.5.2-3
- do not build with freetds when it is not available

* Tue Apr  9 2013 Joe Orton <jorton@redhat.com> - 1.5.2-2
- update for aarch64

* Tue Apr  9 2013 Joe Orton <jorton@redhat.com> - 1.5.2-1
- update to 1.5.2
